val koin_version: String by project
val kotlin_version: String by project
val ktor_version: String by project
val logback_version: String by project
val dynamo_version: String by project
val dynamo_kt_version: String by project
val mockk_version: String by project
val kotlin_reactive_version: String by project
val koin_test_version: String by project
val assertj_core_version: String by project
val localstack_version: String by project


plugins {
    kotlin("jvm") version "2.1.10"
    id("io.ktor.plugin") version "2.3.13"
    kotlin("plugin.serialization") version "1.9.0"
}

group = "tournament.test"
version = "0.0.1-SNAPSHOT"

application {
    mainClass.set("io.ktor.server.netty.EngineMain")

    val isDevelopment: Boolean = project.ext.has("development")
    applicationDefaultJvmArgs = listOf("-Dio.ktor.development=$isDevelopment")
}

repositories {
    mavenCentral()
}

dependencies {
    // Ktor
    implementation("io.ktor:ktor-server-core:$ktor_version")
    implementation("io.ktor:ktor-server-auth:$ktor_version")
    implementation("io.ktor:ktor-server-openapi:$ktor_version")
    implementation("io.ktor:ktor-server-config-yaml:$ktor_version")
    implementation("io.ktor:ktor-server-netty:$ktor_version")
    implementation("io.ktor:ktor-server-status-pages:$ktor_version")
    implementation("io.ktor:ktor-server-cors:$ktor_version")

    // Dependency injection
    implementation("io.insert-koin:koin-ktor:$koin_version")
    implementation("io.insert-koin:koin-logger-slf4j:$koin_version")

    // Content negociation
    implementation("io.ktor:ktor-server-content-negotiation")
    implementation("io.ktor:ktor-serialization-kotlinx-json")
    implementation("ch.qos.logback:logback-classic:$logback_version")

    // Database
    implementation("software.amazon.awssdk:dynamodb-enhanced:$dynamo_version")
    implementation("software.amazon.awssdk:dynamodb:$dynamo_version")
    implementation("dev.andrewohara:dynamokt:$dynamo_kt_version")
    implementation("org.jetbrains.kotlinx:kotlinx-coroutines-reactive:$kotlin_reactive_version")


    // Tests
    testImplementation("io.ktor:ktor-server-test-host")
    testImplementation("io.mockk:mockk:$mockk_version")
    testImplementation("org.jetbrains.kotlin:kotlin-test-junit:$kotlin_version")
    testImplementation("io.insert-koin:koin-test:$koin_test_version")
    testImplementation("org.assertj:assertj-core:$assertj_core_version")
    testImplementation("org.testcontainers:localstack:$localstack_version")
}
