package tournament.test

import tournament.test.configuration.configureExceptionHandling
import tournament.test.configuration.configureKoin
import tournament.test.configuration.configureRouting
import tournament.test.configuration.configureSerialization
import tournament.test.configuration.migrateTables
import io.ktor.server.application.*
import kotlinx.coroutines.runBlocking

fun main(args: Array<String>) {
    io.ktor.server.netty.EngineMain.main(args)
}

fun Application.module() {
    configuration()
    initialize()
}

fun Application.configuration() {
    configureKoin()
    configureSerialization()
    configureExceptionHandling()
    configureRouting()
}

fun Application.initialize() = runBlocking {
    migrateTables()
}