package tournament.test.player.entities

import dev.andrewohara.dynamokt.DynamoKtPartitionKey
import kotlinx.serialization.Serializable

@Serializable
data class Player(
    val pseudo: String,
    val pointsNumber: Int = 0,
)

data class PlayerEntity(
    @DynamoKtPartitionKey
    val pseudo: String,
    val pointsNumber: Int = 0,
)

fun Player.toPlayerEntity(): PlayerEntity {
    return PlayerEntity(
        pseudo = pseudo,
        pointsNumber = pointsNumber,
    )
}

fun PlayerEntity.toPlayer(): Player {
    return Player(
        pseudo = pseudo,
        pointsNumber = pointsNumber,
    )
}