package tournament.test.player.services

import tournament.test.player.dtos.PlayerCreationDTO
import tournament.test.player.dtos.PlayerInfoDTO
import tournament.test.player.dtos.PlayerUpdateDTO
import tournament.test.player.entities.Player

interface PlayerService {
    suspend fun createNewPlayer(playerCreationDTO: PlayerCreationDTO): Player

    suspend fun updatePlayer(playerUpdateDTO: PlayerUpdateDTO): Player

    suspend fun getPlayerByPseudo(pseudo: String): Player

    suspend fun getPlayerInfoByPseudo(pseudo: String): PlayerInfoDTO

    suspend fun getPlayersRanked(): List<PlayerInfoDTO>

    suspend fun deleteAllPlayers()
}