import tournament.test.configuration
import tournament.test.configuration.DynamoDbMigrationService
import tournament.test.initialize
import io.ktor.server.application.*
import org.koin.core.context.loadKoinModules
import org.koin.dsl.module

fun Application.module() {
    configuration()
    // override Database module with testContainers
    loadKoinModules(testDatabaseModule)
    initialize()
}

val testDatabaseModule = module {
    single { TestDynamoDbConfiguration.createDynamoDbClient() }
    single { TestDynamoDbConfiguration.createDataSource(get()) }
    single { DynamoDbMigrationService() }
}